'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// Looks for JWT token, and if it is found, sets some variables.

var authenticate = function () {
	var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
		var _this = this;

		var options = _ref2.options;
		var keys = _ref2.keys;
		var log = _ref2.log;

		var token, payload, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, secret, _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, _secret, jwt_id, user_id;

		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						// A little helper which can be called from routes
						// as `ctx.role('administrator')`
						// which will throw if the user isn't administrator.
						// The `roles` are taken from JWT payload.
						this.role = function () {
							for (var _len = arguments.length, roles = Array(_len), _key = 0; _key < _len; _key++) {
								roles[_key] = arguments[_key];
							}

							if (!_this.user) {
								throw new _errors2.default.Unauthenticated();
							}

							var _iteratorNormalCompletion = true;
							var _didIteratorError = false;
							var _iteratorError = undefined;

							try {
								for (var _iterator = (0, _getIterator3.default)(roles), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
									var role = _step.value;
									var _iteratorNormalCompletion2 = true;
									var _didIteratorError2 = false;
									var _iteratorError2 = undefined;

									try {
										for (var _iterator2 = (0, _getIterator3.default)(_this.user.roles), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
											var user_role = _step2.value;

											if (user_role === role) {
												return true;
											}
										}
									} catch (err) {
										_didIteratorError2 = true;
										_iteratorError2 = err;
									} finally {
										try {
											if (!_iteratorNormalCompletion2 && _iterator2.return) {
												_iterator2.return();
											}
										} finally {
											if (_didIteratorError2) {
												throw _iteratorError2;
											}
										}
									}
								}
							} catch (err) {
								_didIteratorError = true;
								_iteratorError = err;
							} finally {
								try {
									if (!_iteratorNormalCompletion && _iterator.return) {
										_iterator.return();
									}
								} finally {
									if (_didIteratorError) {
										throw _iteratorError;
									}
								}
							}

							throw new _errors2.default.Unauthorized('One of the following roles is required: ' + roles);
						};

						// Get JWT token from incoming HTTP request
						token = get_jwt_token(this);

						// If no JWT token was found, then done

						if (token) {
							_context.next = 4;
							break;
						}

						return _context.abrupt('return');

					case 4:

						// JWT token (is now accessible from Koa's `ctx`)
						this.accessToken = token;

						// Verify JWT token integrity
						// by checking its signature using the supplied `keys`

						payload = void 0;
						_iteratorNormalCompletion3 = true;
						_didIteratorError3 = false;
						_iteratorError3 = undefined;
						_context.prev = 9;
						_iterator3 = (0, _getIterator3.default)(keys);

					case 11:
						if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
							_context.next = 77;
							break;
						}

						secret = _step3.value;
						_context.prev = 13;

						payload = _jsonwebtoken2.default.verify(token, secret);
						return _context.abrupt('break', 77);

					case 18:
						_context.prev = 18;
						_context.t0 = _context['catch'](13);

						if (!(_context.t0.name === 'TokenExpiredError')) {
							_context.next = 70;
							break;
						}

						if (!options.refreshAccessToken) {
							_context.next = 67;
							break;
						}

						_context.prev = 22;
						_context.next = 25;
						return options.refreshAccessToken(this);

					case 25:
						token = _context.sent;
						_context.next = 31;
						break;

					case 28:
						_context.prev = 28;
						_context.t1 = _context['catch'](22);

						log.error(_context.t1);

					case 31:
						if (!token) {
							_context.next = 67;
							break;
						}

						_iteratorNormalCompletion4 = true;
						_didIteratorError4 = false;
						_iteratorError4 = undefined;
						_context.prev = 35;
						_iterator4 = (0, _getIterator3.default)(keys);

					case 37:
						if (_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done) {
							_context.next = 53;
							break;
						}

						_secret = _step4.value;
						_context.prev = 39;

						payload = _jsonwebtoken2.default.verify(token, _secret);
						return _context.abrupt('break', 53);

					case 44:
						_context.prev = 44;
						_context.t2 = _context['catch'](39);

						if (!(_context.t2.name === 'JsonWebTokenError' && _context.t2.message === 'invalid signature')) {
							_context.next = 48;
							break;
						}

						return _context.abrupt('continue', 50);

					case 48:

						// Some other non-JWT-related error
						log.error(_context.t2);
						return _context.abrupt('break', 53);

					case 50:
						_iteratorNormalCompletion4 = true;
						_context.next = 37;
						break;

					case 53:
						_context.next = 59;
						break;

					case 55:
						_context.prev = 55;
						_context.t3 = _context['catch'](35);
						_didIteratorError4 = true;
						_iteratorError4 = _context.t3;

					case 59:
						_context.prev = 59;
						_context.prev = 60;

						if (!_iteratorNormalCompletion4 && _iterator4.return) {
							_iterator4.return();
						}

					case 62:
						_context.prev = 62;

						if (!_didIteratorError4) {
							_context.next = 65;
							break;
						}

						throw _iteratorError4;

					case 65:
						return _context.finish(62);

					case 66:
						return _context.finish(59);

					case 67:
						if (!payload) {
							_context.next = 69;
							break;
						}

						return _context.abrupt('break', 77);

					case 69:
						throw new _errors2.default.Access_token_expired();

					case 70:
						if (!(_context.t0.name === 'JsonWebTokenError' && _context.t0.message === 'invalid signature')) {
							_context.next = 72;
							break;
						}

						return _context.abrupt('continue', 74);

					case 72:

						// Some other non-JWT-related error.
						// Shouldn't prevent the user from at least seeing a page
						// therefore not rethrowing this error.
						log.error(_context.t0);
						return _context.abrupt('break', 77);

					case 74:
						_iteratorNormalCompletion3 = true;
						_context.next = 11;
						break;

					case 77:
						_context.next = 83;
						break;

					case 79:
						_context.prev = 79;
						_context.t4 = _context['catch'](9);
						_didIteratorError3 = true;
						_iteratorError3 = _context.t4;

					case 83:
						_context.prev = 83;
						_context.prev = 84;

						if (!_iteratorNormalCompletion3 && _iterator3.return) {
							_iterator3.return();
						}

					case 86:
						_context.prev = 86;

						if (!_didIteratorError3) {
							_context.next = 89;
							break;
						}

						throw _iteratorError3;

					case 89:
						return _context.finish(86);

					case 90:
						return _context.finish(83);

					case 91:
						if (payload) {
							_context.next = 93;
							break;
						}

						return _context.abrupt('return');

					case 93:
						if (!options.validateAccessToken) {
							_context.next = 96;
							break;
						}

						if (options.validateAccessToken(payload, this)) {
							_context.next = 96;
							break;
						}

						return _context.abrupt('return');

					case 96:

						// Token payload can be accessed through `ctx`
						this.accessTokenPayload = payload;

						// Fire "on user request" hook
						if (options.onUserRequest) {
							options.onUserRequest(token, this);
						}

						// JWT token ID
						jwt_id = payload.jti;

						// `subject`
						// (which is a user id)

						user_id = payload.sub;

						// // Optional JWT token validation (by id)
						// // (for example, that it has not been revoked)
						// if (validateToken)
						// {
						// 	// Can validate the token via a request to a database, for example.
						// 	// Checks for `valid` property value inside the result object.
						// 	// (There can possibly be other properties such as `reason`)
						// 	const is_valid = (await validateToken(token, this)).valid
						//
						// 	// If the JWT token happens to be invalid
						// 	// (expired or revoked, for example), then exit.
						// 	if (!is_valid)
						// 	{
						// 		// this.authenticationError = new errors.Unauthenticated('AccessTokenRevoked')
						// 		return
						// 	}
						// }

						// JWT token ID is now accessible via Koa's `ctx`

						this.accessTokenId = jwt_id;

						// Extracts user data (description) from JWT token payload
						// (`user` is now accessible via Koa's `ctx`)
						this.user = options.userInfo ? options.userInfo(payload) : {};

						// Sets user id
						this.user.id = user_id;

						// Extra payload fields:
						//
						// 'iss' // Issuer
						// 'sub' // Subject
						// 'aud' // Audience
						// 'exp' // Expiration time
						// 'nbf' // Not before
						// 'iat' // Issued at 
						// 'jti' // JWT ID

						// JWT token payload is accessible via Koa's `ctx`
						this.accessTokenPayload = payload;

					case 104:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, this, [[9, 79, 83, 91], [13, 18], [22, 28], [35, 55, 59, 67], [39, 44], [60,, 62, 66], [84,, 86, 90]]);
	}));

	return function authenticate(_x) {
		return _ref.apply(this, arguments);
	};
}();

// Koa middleware creator


exports.default = function (options) {
	// Koa middleware
	return function () {
		var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(ctx, next) {
			return _regenerator2.default.wrap(function _callee2$(_context2) {
				while (1) {
					switch (_context2.prev = _context2.next) {
						case 0:
							_context2.next = 2;
							return authenticate.call(ctx, options);

						case 2:
							_context2.next = 4;
							return next();

						case 4:
						case 'end':
							return _context2.stop();
					}
				}
			}, _callee2, this);
		}));

		return function (_x2, _x3) {
			return _ref3.apply(this, arguments);
		};
	}();
};

exports.issue_jwt_token = issue_jwt_token;
exports.verify_jwt_token = verify_jwt_token;

var _jsonwebtoken = require('jsonwebtoken');

var _jsonwebtoken2 = _interopRequireDefault(_jsonwebtoken);

var _errors = require('../errors');

var _errors2 = _interopRequireDefault(_errors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Looks for JWT token inside HTTP Authorization header
function get_jwt_token(ctx) {
	// Parses "Authorization: Bearer ${token}"
	if (ctx.header.authorization) {
		var match = ctx.header.authorization.match(/^Bearer (.+)$/i);

		if (match) {
			return match[1];
		}
	}

	// (doesn't read cookies anymore to protect users from CSRF attacks)
	// // Tries the "authentication" cookie
	// if (ctx.cookies.get('authentication'))
	// {
	// 	return ctx.cookies.get('authentication')
	// }
}

// Generates and signs a JWT token
function issue_jwt_token(_ref4) {
	var payload = _ref4.payload;
	var key = _ref4.key;
	var userId = _ref4.userId;
	var tokenId = _ref4.tokenId;
	var issuer = _ref4.issuer;
	var audience = _ref4.audience;
	var expiresIn = _ref4.expiresIn;
	var notBefore = _ref4.notBefore;
	var algorithm = _ref4.algorithm;
	var noTimestamp = _ref4.noTimestamp;
	var header = _ref4.header;

	if (arguments.length !== 1) {
		throw new Error("`jwt` function must take a single argument: an object { payload, key, userId, tokenId, ... }");
	}

	if (!key) {
		throw new Error('JWT encryption "key" wasn\'t supplied');
	}

	var token = _jsonwebtoken2.default.sign(payload, key, {
		subject: userId,
		jwtid: tokenId,

		// (optional)
		// The iss (issuer) claim identifies the principal that issued the JWT.
		// E.g. `google.com`.
		issuer: issuer,

		// (optional)
		// "audience" is where this token will be applied.
		// Typically, the base address of the resource being accessed,
		// such as "contoso.com".
		// The JWT will contain an "aud" claim that specifies which
		// Resource Servers the JWT is valid for.
		// If the "aud" contains "www.webapp.com",
		// but the client app tries to use the JWT on "secret.webapp.com",
		// then access will be denied because that Resource Server
		// will see that the JWT was not meant for it.
		audience: audience,

		// (optional)
		// (in seconds)
		// After this time passes the JWT will be considered invalid.
		// E.g.: 60, "2 days", "10h", "7d"
		expiresIn: expiresIn,

		// (optional)
		// (in seconds)
		// The not-before time claim identifies the time
		// on which the JWT will start to be accepted for processing.
		// E.g.: 60, "2 days", "10h", "7d"
		notBefore: notBefore,

		// (optional)
		algorithm: algorithm,

		// (optional)
		noTimestamp: noTimestamp,

		// (optional)
		header: header
	});

	return token;
}

// Verifies a JWT token returning its payload
// if it's valid and returning nothing otherwise.
//
// `{ ignoreExpiration: true }` can be passed to ignore token expiration.
//
function verify_jwt_token(token, keys, options) {
	var latest_error = void 0;

	var _iteratorNormalCompletion5 = true;
	var _didIteratorError5 = false;
	var _iteratorError5 = undefined;

	try {
		for (var _iterator5 = (0, _getIterator3.default)(keys), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
			var secret = _step5.value;

			try {
				return _jsonwebtoken2.default.verify(token, secret, options);
			} catch (error) {
				// Try another `secret`
				if (error.name === 'JsonWebTokenError' && error.message === 'invalid signature') {
					latest_error = error;
					continue;
				}

				// Some other non-JWT-related error
				throw error;
			}
		}
	} catch (err) {
		_didIteratorError5 = true;
		_iteratorError5 = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion5 && _iterator5.return) {
				_iterator5.return();
			}
		} finally {
			if (_didIteratorError5) {
				throw _iteratorError5;
			}
		}
	}

	throw latest_error;
}
//# sourceMappingURL=authentication.js.map